/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _COMMON_H
#define _COMMON_H

#include <artnet/artnet.h>
#include <string.h>
#include <gtk/gtk.h>
#include "audio_window.h"
#include "memory.h"

#include <stdlib.h>
#include <assert.h>
#include <stdio.h>

#define MAX_NODES 	100

#define TICKS_PER_SECOND 25

enum {
	COLUMN_NODE,
	NUMB_COLS
};

typedef enum {
	FADE_START,
	IN_FADE,
	NO_FADE,
	FADE_CHANGE
} fade_status_e ;

enum {
	COLUMN_1,
	COLUMN_2,
	COLUMN_3,
	COLUMN_4,
	COLUMN_5,
	COLUMN_6,
	COLUMN_7,
	COLUMN_8,
	COLUMN_9,
	COLUMN_10,
	COLUMN_11,
	COLUMN_12,
	NUMB_COLS_TABLE
};

enum {
	NAME ,
	NUMB_COLS_LIST
};


extern artnet_node node ;
extern artnet_node_entry active_node ;
extern int nodes_found ;

extern int ticks_total ;
extern int ticks ;
extern fade_status_e fade_status ;
extern uint8_t data_output[SLIDERS] ;
extern uint8_t data_sliders[SLIDERS] ;
extern uint8_t data_start[SLIDERS] ;

extern int flashes_on[FLASHES];

extern int fade_time ;
extern int active_port;

//functions

int get_slider_values(GtkWidget *widget, uint8_t *data, int length) ;
int set_slider_values(GtkWidget *widget, uint8_t *data, int length) ;

int blackout(GtkWidget *widget) ;
int all_on(GtkWidget *widget) ;
	
void slow_mode(GtkWidget *widget) ;
void audio_callback (audio_events event, void *usr_data) ;

int on_reply_recv(artnet_node n, void *pp, void *data) ;
int timeout(gpointer data) ;

void add_slow_scene_to_table(GtkWidget* widget, uint8_t *data, int length) ;

int show_beat_window(GtkWidget *beat_window, beat_scene scene) ;

void add_beat_scene_to_table(GtkWidget* widget, beat_scene *scene) ;
#endif /* _COMMON_H */
