/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include "common.h" 

#include "callbacks.h"

#include "interface.h"
#include "support.h"

	
/*
 * Called when there is data on the network
 *
 */
void sd_event(gpointer data, gint source,  GdkInputCondition con) {
	artnet_node n = (artnet_node) data; 
	
	artnet_read(n,0) ;
}


int main (int argc, char *argv[]) {
  GtkWidget *window1, *audioWindow, *beat_mode_window;
  GtkWidget *audioWindow_item ;
  GtkListStore *listStore ; 
  GtkTreeView *treeView ;
  GtkCellRenderer     *renderer;
  GtkComboBox *combobox1 ;
  GtkButton *button ;
	
  int i ;
  gchar *gstr;
	
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  window1 = create_window1();
	
  // beat mode window setup
  beat_mode_window = create_beat_mode_window () ;
	
  button = (GtkButton*) lookup_widget(window1, "add_beat_mode_button") ;
  
  g_signal_connect ((gpointer) button, "clicked",
                    G_CALLBACK (on_beat_mode_button_clicked),
                    beat_mode_window);
	
  button = (GtkButton*) lookup_widget(beat_mode_window, "ok_button") ;
  g_signal_connect ((gpointer) button, "clicked",
                    G_CALLBACK (on_ok_button_clicked),
                    window1);


	
	
  // create new audio window 
  audioWindow = audio_window_create() ;
		


  // set up node list ;
  combobox1= (GtkComboBox*) lookup_widget(window1, "combobox1") ;  
  


  // set up table
  treeView = (GtkTreeView*) lookup_widget(window1, "treeview1") ;
  listStore = gtk_list_store_new(NUMB_COLS_TABLE,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT,G_TYPE_INT) ;
  
  for(i=0; i < SLIDERS; i++) { 
    renderer = gtk_cell_renderer_text_new ();
    gstr = g_strdup_printf("Chan %d", i+1) ;
    gtk_tree_view_insert_column_with_attributes (treeView,
                                               -1,      
                                               gstr,  
                                               renderer,
                                               "text", i,
                                               NULL);
  }
											   
  gtk_tree_view_set_model(treeView, (GtkTreeModel*) listStore) ;

  // set second table
   treeView = (GtkTreeView*) lookup_widget(window1, "treeview2") ;
   listStore = gtk_list_store_new(NUMB_COLS_LIST,G_TYPE_STRING) ;
  
   renderer = gtk_cell_renderer_text_new ();
   gtk_tree_view_insert_column_with_attributes (treeView,
                                               -1,      
                                               "Scene Name",  
                                               renderer,
                                               "text", 0,
                                               NULL);

											   
  gtk_tree_view_set_model(treeView, (GtkTreeModel*) listStore) ;
  
  
	
  // set handler for audio_window toggled
  audioWindow_item = lookup_widget(window1, "audio_window1") ;
  
  g_signal_connect ((gpointer) audioWindow_item, "toggled",
                    G_CALLBACK (on_audio_window1_toggled),
                    audioWindow);
	
  // set delete handler
  g_signal_connect( audioWindow, "delete_event",
                    G_CALLBACK (on_audio_window_delete),
                    window1);	
  
  // set up artnet node
  // fix me here
  if(argc > 1) {
	  node = artnet_new(argv[1],0) ;
  } else {
     node = artnet_new(NULL,0) ; 
  }
  init_memory() ;
 
  active_node = NULL ;
  nodes_found = 0;
	
  artnet_set_short_name(node, "ArtNet Controller") ;
  artnet_set_long_name(node, "ArtNet Controller, Linux, libartnet") ;
  artnet_set_node_type(node, ARTNET_SRV) ;

  artnet_set_handler(node,ARTNET_REPLY_HANDLER, on_reply_recv, window1) ;
  
  artnet_set_subnet_addr(node, 0) ;

  for(i=0; i < ARTNET_MAX_PORTS; i++) {
  	artnet_set_port_type(node, i, ARTNET_ENABLE_INPUT, ARTNET_PORT_DMX) ;
  	artnet_set_port_addr(node, i, ARTNET_INPUT_PORT, i) ;
  }
  
  artnet_start(node) ;

  gdk_input_add( artnet_get_sd(node,0) , GDK_INPUT_READ,sd_event, (gpointer)node );
  gdk_input_add( artnet_get_sd(node,1) , GDK_INPUT_READ,sd_event, (gpointer)node ) ;

  g_timeout_add(1000/ TICKS_PER_SECOND, timeout, (gpointer) window1) ;
  
  fade_status = NO_FADE;
  gtk_widget_show (window1);
  gtk_main ();
  return 0;
}
